package cz.muni.fi.pb162.exceptions;


/**
 * Tato trida reprezentuje dopis zaslany na konkretni adresu.
 * 
 * @author Radek Oslejsek
 * @version 2007-11-01
 */
public class RegisteredLetter
{
    private String address;
    private String text;
    
    /**
     * Vytvori novy dopis se zadanym textem a adresatem
     * 
     * @param text text dopisu
     * @param address adresa prijemce
     */
    public RegisteredLetter(String text, String address) {
        this.text = text;
        this.address = address;
    }
    
    /**
     * Vrati adresu prijemce.
     *
     * @return adresu prijemce
     */
    public String getAddress() {
        return address;
    }

    public String toString() {
        return address + ": " + text;
    }
}
