package cz.muni.fi.pb162.exceptions;


import java.util.Random;

/**
 * Trida reprezentuje jednoduchy adresar mest a ulic, ktery 
 * adresu prijemce nahodne potvrdi nebo odmitne
 * 
 * @author Radek Oslejsek
 * @version 2007-11-01
 */
public class SimpleAddressBook implements AddressBook
{
    Random random = new Random();
    int retries = random.nextInt(12);
    
    public Mailman checkAddress(String recipient) throws BadAddressException
    {
        retries--;
        if (retries <= 0) {
            retries = random.nextInt(12);
            throw new BadAddressException("Bad address (counter: "+retries+")");
        } else {
            return new SimpleMailman(recipient);
        }
    }
    
    private class SimpleMailman implements Mailman
    {   
        private int retries = random.nextInt(8);
        private String recipient;
    
        private SimpleMailman(String recipient) {
            this.recipient = recipient;
        }
    
        public void deliverLetter(RegisteredLetter letter) 
        throws RecipientMissedException, LetterRefusedException {
            retries--;
            if (retries <= 0) {
                retries = random.nextInt(8);
		if (random.nextInt(2) == 0) {
		    System.out.println("Letter '" + letter +"' has been delivered to "  + recipient);
                } else {
                    throw new LetterRefusedException("Letter refused by recipient " + recipient + " (counter: " + retries + ").");
                }
            } else {
		throw new RecipientMissedException("Missed recipient " + recipient + " (counter: " + retries + ").");
            }
        }
    }
}
